<template>
  <div class="wrapper" :class="{ opened }">
    <div class="tabs">
      <div
        class="tab"
        v-for="val in tabs"
        :class="{ active: val.key === tab }"
        @click="changeTab(val.key)"
      >
        <div class="tab-label">
          <span>{{ val.name }}</span
          ><span v-if="val.key === tab"> {{ val.range }}</span>
        </div>
      </div>
    </div>
    <div class="list">
      <div
        class="item"
        v-for="itemTime in times"
        :class="{ active: itemTime === time }"
        @click="chooseTime(itemTime)"
      >
        <span class="time">{{ itemTime }}</span>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    opened: {
      type: Boolean,
      required: true
    },
    tabs: {
      type: Array,
      required: true
    },
    tab: {
      type: String
    },
    times: {
      type: Array,
      required: true
    },
    time: {
      type: String,
      required: true
    }
  },

  computed: {
    value() {
      return {
        tab: this.tab,
        time: this.time
      };
    }
  },

  methods: {
    changeTab(val) {
      this.$emit("changed", {
        ...this.value,
        tab: val
      });
    },

    chooseTime(val) {
      this.$emit("changed", {
        ...this.value,
        time: val
      });
    }
  }
};
</script>

<style lang="scss" scoped>
.wrapper {
  max-height: 0;
  overflow: hidden;
  transition: max-height 0.4s;

  &.opened {
    max-height: 500px;
  }
}

.tabs {
  display: flex;
  line-height: 46px;
  text-align: center;
  color: $color-secondary-black;
  margin-bottom: 20px;
  border-bottom: 1px $color-silver-grey solid;

  @include media-breakpoint-up(md) {
    display: block;
    text-align: left;
  }
}

.tab {
  flex: 1;
  cursor: pointer;
  white-space: nowrap;

  @include media-breakpoint-up(md) {
    display: inline-block;
    margin-right: 40px;
  }
}

.tab.active {
  position: relative;
  color: $color-skm-red;

  &::after {
    content: "";
    position: absolute;
    right: 0;
    bottom: 0;
    width: 100%;
    height: 3px;
    background: $color-skm-red;
  }
}

.tab-label {
  display: inline-block;
}

.list {
  display: flex;
  flex-wrap: wrap;
  margin-left: -6px;
  margin-top: -6px;

  .item {
    width: 25%;
    cursor: pointer;

    &.active .time {
      color: $color-white;
      background: $color-skm-red;
      border: none;
    }

    @include media-breakpoint-up(md) {
      width: 98px;
    }
  }

  .time {
    display: block;
    margin: 6px;
    text-align: center;
    border: 1px $color-silver-grey solid;
    border-radius: 2px;
    line-height: 36px;
    box-sizing: border-box;
    background: $color-white;
  }
}
</style>
